/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kubeedge/sedna/pkg/apis/sedna/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeIncrementalLearningJobs implements IncrementalLearningJobInterface
type FakeIncrementalLearningJobs struct {
	Fake *FakeSednaV1alpha1
	ns   string
}

var incrementallearningjobsResource = schema.GroupVersionResource{Group: "sedna.io", Version: "v1alpha1", Resource: "incrementallearningjobs"}

var incrementallearningjobsKind = schema.GroupVersionKind{Group: "sedna.io", Version: "v1alpha1", Kind: "IncrementalLearningJob"}

// Get takes name of the incrementalLearningJob, and returns the corresponding incrementalLearningJob object, and an error if there is any.
func (c *FakeIncrementalLearningJobs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.IncrementalLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(incrementallearningjobsResource, c.ns, name), &v1alpha1.IncrementalLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IncrementalLearningJob), err
}

// List takes label and field selectors, and returns the list of IncrementalLearningJobs that match those selectors.
func (c *FakeIncrementalLearningJobs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.IncrementalLearningJobList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(incrementallearningjobsResource, incrementallearningjobsKind, c.ns, opts), &v1alpha1.IncrementalLearningJobList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.IncrementalLearningJobList{ListMeta: obj.(*v1alpha1.IncrementalLearningJobList).ListMeta}
	for _, item := range obj.(*v1alpha1.IncrementalLearningJobList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested incrementalLearningJobs.
func (c *FakeIncrementalLearningJobs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(incrementallearningjobsResource, c.ns, opts))

}

// Create takes the representation of a incrementalLearningJob and creates it.  Returns the server's representation of the incrementalLearningJob, and an error, if there is any.
func (c *FakeIncrementalLearningJobs) Create(ctx context.Context, incrementalLearningJob *v1alpha1.IncrementalLearningJob, opts v1.CreateOptions) (result *v1alpha1.IncrementalLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(incrementallearningjobsResource, c.ns, incrementalLearningJob), &v1alpha1.IncrementalLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IncrementalLearningJob), err
}

// Update takes the representation of a incrementalLearningJob and updates it. Returns the server's representation of the incrementalLearningJob, and an error, if there is any.
func (c *FakeIncrementalLearningJobs) Update(ctx context.Context, incrementalLearningJob *v1alpha1.IncrementalLearningJob, opts v1.UpdateOptions) (result *v1alpha1.IncrementalLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(incrementallearningjobsResource, c.ns, incrementalLearningJob), &v1alpha1.IncrementalLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IncrementalLearningJob), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeIncrementalLearningJobs) UpdateStatus(ctx context.Context, incrementalLearningJob *v1alpha1.IncrementalLearningJob, opts v1.UpdateOptions) (*v1alpha1.IncrementalLearningJob, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(incrementallearningjobsResource, "status", c.ns, incrementalLearningJob), &v1alpha1.IncrementalLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IncrementalLearningJob), err
}

// Delete takes name of the incrementalLearningJob and deletes it. Returns an error if one occurs.
func (c *FakeIncrementalLearningJobs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(incrementallearningjobsResource, c.ns, name), &v1alpha1.IncrementalLearningJob{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeIncrementalLearningJobs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(incrementallearningjobsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.IncrementalLearningJobList{})
	return err
}

// Patch applies the patch and returns the patched incrementalLearningJob.
func (c *FakeIncrementalLearningJobs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.IncrementalLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(incrementallearningjobsResource, c.ns, name, pt, data, subresources...), &v1alpha1.IncrementalLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IncrementalLearningJob), err
}
